import json
import typing

from django.contrib.staticfiles import finders

if typing.TYPE_CHECKING:
    from pretix.base.models import Event

VIA_DEFAULT_TICKET_LAYOUT = json.dumps(
    [
        {
            "type": "textarea",
            "locale": "nl",
            "left": "16.87",
            "bottom": "244.56",
            "fontsize": "16.0",
            "color": [0, 0, 0, 1],
            "fontfamily": "Open Sans",
            "bold": True,
            "italic": False,
            "width": "174.09",
            "downward": False,
            "content": "event_name",
            "text": "Voorbeeld evenementnaam",
            "rotation": 0,
            "align": "left",
        },
        {
            "type": "textarea",
            "locale": "nl",
            "left": "16.87",
            "bottom": "237.80",
            "fontsize": "13.0",
            "color": [0, 0, 0, 1],
            "fontfamily": "Open Sans",
            "bold": False,
            "italic": False,
            "width": "104.97",
            "downward": False,
            "content": "itemvar",
            "text": "Voorbeeldproduct – voorbeeldvariant",
            "rotation": 0,
            "align": "left",
        },
        {
            "type": "textarea",
            "locale": "nl",
            "left": "16.87",
            "bottom": "176.80",
            "fontsize": "11.0",
            "color": [0, 0, 0, 1],
            "fontfamily": "Open Sans",
            "bold": False,
            "italic": False,
            "width": "110.00",
            "downward": False,
            "content": "attendee_name",
            "text": "John Doe",
            "rotation": 0,
            "align": "left",
        },
        {
            "type": "textarea",
            "locale": "nl",
            "left": "16.87",
            "bottom": "189.76",
            "fontsize": "11.0",
            "color": [0, 0, 0, 1],
            "fontfamily": "Open Sans",
            "bold": False,
            "italic": False,
            "width": "110.00",
            "downward": False,
            "content": "event_begin",
            "text": "31-05-2017 20:00",
            "rotation": 0,
            "align": "left",
        },
        {
            "type": "textarea",
            "locale": "nl",
            "left": "16.87",
            "bottom": "202.96",
            "fontsize": "11.0",
            "color": [0, 0, 0, 1],
            "fontfamily": "Open Sans",
            "bold": False,
            "italic": False,
            "width": "110.00",
            "downward": False,
            "content": "event_location",
            "text": "Voorbeeldstad",
            "rotation": 0,
            "align": "left",
        },
        {
            "type": "textarea",
            "locale": "nl",
            "left": "12.45",
            "bottom": "9.85",
            "fontsize": "11.0",
            "color": [0, 0, 0, 1],
            "fontfamily": "Open Sans",
            "bold": False,
            "italic": False,
            "width": "30.63",
            "downward": False,
            "content": "order",
            "text": "A1B2C",
            "rotation": 0,
            "align": "left",
        },
        {
            "type": "textarea",
            "locale": "nl",
            "left": "16.87",
            "bottom": "230.80",
            "fontsize": "11.0",
            "color": [0, 0, 0, 1],
            "fontfamily": "Open Sans",
            "bold": False,
            "italic": False,
            "width": "45.00",
            "downward": False,
            "content": "price",
            "text": "123,45 EUR",
            "rotation": 0,
            "align": "left",
        },
        {
            "type": "textarea",
            "locale": "nl",
            "left": "107.18",
            "bottom": "10.48",
            "fontsize": "11.0",
            "color": [0, 0, 0, 1],
            "fontfamily": "Open Sans",
            "bold": False,
            "italic": False,
            "width": "90.00",
            "downward": False,
            "content": "secret",
            "text": "tdmruoekvkpbv1o2mv8xccvqcikvr58u",
            "rotation": 0,
            "align": "right",
        },
        {
            "type": "barcodearea",
            "left": "126.98",
            "bottom": "181.72",
            "size": "64.00",
            "nowhitespace": False,
        },
        {
            "type": "textarea",
            "locale": "nl",
            "left": "16.87",
            "bottom": "186.37",
            "fontsize": "11.0",
            "color": [0, 0, 0, 1],
            "fontfamily": "Open Sans",
            "bold": True,
            "italic": False,
            "width": "50.00",
            "downward": True,
            "content": "other",
            "text": "Naam:",
            "rotation": 0,
            "align": "left",
        },
        {
            "type": "textarea",
            "locale": "nl",
            "left": "16.87",
            "bottom": "200.18",
            "fontsize": "11.0",
            "color": [0, 0, 0, 1],
            "fontfamily": "Open Sans",
            "bold": True,
            "italic": False,
            "width": "50.00",
            "downward": True,
            "content": "other",
            "text": "Datum & Tijdstip:",
            "rotation": 0,
            "align": "left",
        },
        {
            "type": "textarea",
            "locale": "nl",
            "left": "16.87",
            "bottom": "213.13",
            "fontsize": "11.0",
            "color": [0, 0, 0, 1],
            "fontfamily": "Open Sans",
            "bold": True,
            "italic": False,
            "width": "50.00",
            "downward": True,
            "content": "other",
            "text": "Locatie:",
            "rotation": 0,
            "align": "left",
        },
    ]
)


def create_via_ticket_layout(event: "Event"):
    if not event.ticket_layouts.exists():
        layout = event.ticket_layouts.create(
            event=event,
            default=True,
            name="Default via-ticket",
            layout=VIA_DEFAULT_TICKET_LAYOUT,
        )
        with open(finders.find("pretix_via/default_ticket_background.pdf"), "rb") as f:
            layout.background.save("background.pdf", f)
